<template>
  <AppAbstractPage
    :breadcrumbs="breadcrumbs"
    class="goodsInfoPage">
    <AppSearch
      slot="abstractPage-search"
      class="_on-page"/>
    <div
      slot="heading"
      class="pageHeading">
      <h1 class="heading _h1">
        {{ titleH1 }}
      </h1>
    </div>

    <template
      v-if="partInfo.valid"
      slot="content">
      <!-- Блок описания и фото запчасти -->
      <GoodsInfo :goods-info="partInfo"/>

      <!-- Блок закладок -->
      <Subsections
        :has-tabs-mobile="true"
        :has-position-fixed-mobile="false"
        :subsections="subsections"
        :active="activeSubsection"
        button-back-text="Информация о товаре">
        <!-- Оригиналы-->
        <div
          class="subsectionContent-original"
          slot="content-origin">
          <!-- таблицы для предложений оригиналов и аналогов -->
          <section class="offers">
            <PpnWarning v-if="!countOffersRegularGrids && countPartsWithoutCity"/>

            <div
              v-if="partInfo.valid"
              class="offers-filters"
              :class="{ '-open-in-mobile': $options.displayStates.FILTERS === display }">
              <PpnFilters
                v-model="filtersModel"
                :scrollable="filtersMobileScrollable"
                :filters="filtersValues"
                :grids="gridsInfo"
                :count-filters-selected="countFiltersSelected"
                :has-loading="loading"
                @change-type="typeChange"
                @clear-filter-location="onClearFilterLocation"
                @hide="changeDisplay($options.displayStates.LIST)"
                @reset="resetFilters"/>
            </div>

            <PpnWarning v-if="!countOffersRegularGrids && !countPartsWithoutCity"/>

            <div
              v-if="!isShowMap"
              class="offers-controlDisplay -is-desktop">
              <AppInputRadio
                class="_form-circle"
                name="map"
                :map-disabled="mapButtonDisabled"
                :value="isShowMap"
                @input="onSwitchMap"
                :list="[
                  { label: 'Списком', value: false },
                  { label:'На карте', value: true }]"/>
            </div>

            <div class="offers-controlDisplay -is-mobile">
              <AppButton
                @click.native="changeDisplay($options.displayStates.FILTERS)"
                :classes="['buttonFilters', '_blue']">
                <span
                  slot="button-item"
                  class="button-item">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/filter-funnel.svg">
                  Фильтры
                </span>
              </AppButton>
              <AppButton
                :classes="['buttonMap', '-hasPointerEvents']"
                :disabled="!hasMap || !countOffersRegularGrids"
                @click.native="isShowMap = true">
                <span
                  v-tooltip="mapTooltipButton"
                  slot="button-item"
                  class="button-item">
                  На карте
                </span>
              </AppButton>
            </div>

            <template v-if="isShowMap">
              <AppEntitiesInMap
                :grid="mapGrid"
                :part-title="partInfo && partInfo.partManufacturer + ', ' + partInfo.partVendorCode"
                :location="resolvedFilterLocation"
                :active-type="activeTypes"
                @order-change="fetchByOrder"
                @change-display="changeDisplay($options.displayStates.FILTERS)"
                @change-active-types="activeTypes = $event"
                @show-grids="onShowGrids"
                @fast-order="fastOrderShow"
              >
                <template v-slot:heading="{ entitiesCount, selectedTypes }">
                  <div
                    class="heading _h3">
                    {{ mapHeading(selectedTypes, entitiesCount) }}
                  </div>
                </template>
                <template #switcher>
                  <div class="offers-controlDisplay -is-desktop">
                    <AppInputRadio
                      class="_form-circle"
                      name="map"
                      :value="isShowMap"
                      @input="onSwitchMap"
                      :list="[
                        { label: 'Списком', value: false },
                        { label: 'На карте', value: true }]"/>
                  </div>
                </template>
              </AppEntitiesInMap>
            </template>

            <template v-else>
              <GridOffers
                v-for="gridType in gridsByTypes"
                :key="gridType"
                :grid="gridsInfo[gridType]"
                :auth="auth"
                :show-item-hrefs="gridType === $options.gridTypes.INTERNAL_COUNTERPART
                || gridType === $options.gridTypes.FOREIGN_COUNTERPART"
                :has-lazy-load="lazyLoadEnabled(gridType)"
                @fast-order="fastOrderShow"
                @load-data="showMore(gridType); $ym('show_more_announcements')"
                @order-change="fetchByOrder(gridType, $event)">
                <h2
                  class="heading _h3"
                  slot="heading">
                  {{ gridsInfo[gridType].name }}
                </h2>
                <SelectSorting
                  :options="sorting"
                  :value="selectedSorting"
                  slot="sorting"
                  @order-change="onOrderChange"/>
              </GridOffers>
            </template>
          </section>
        </div>
        <!-- Аналоги и Заменители-->
        <div
          class="subsectionContent-analog"
          slot="content-analog">
          <GridCounterparts
            :grid="gridCounterparts">
            <h2
              class="heading _h3"
              slot="heading">
              {{ titleH1 }}:
              {{ gridCounterpartsTotalAmount }}
              {{ gridCounterpartsTotalAmount | transChoose(['предложение', 'предложения', 'предложений']) }}
            </h2>
          </GridCounterparts>
        </div>
        <!-- Характеристики -->
        <div
          class="subsectionContent-characteristics"
          slot="content-characteristics">

          <h2 class="heading _h3">Характеристики</h2>
          <ul class="boxList" >
            <li
              v-for="(characteristic, i) in partInfo.characteristics"
              :key="i"
              class="boxList-item">
              <div class="boxList-name">
                <span>{{ characteristic.name }}</span>
              </div>
              <div class="boxList-value">
                <span>{{ characteristic.value }}</span>
              </div>
            </li>
          </ul>
        </div>
        <!-- Применяемость -->
        <div
          class="subsectionContent-applicability"
          slot="content-applicability">
          <PartApplicability
            :show-content="{ desktop: 'body', mobile: 'body' }"
            :structure="$options.applicabilityStructure"
            :entities="partInfo.applicability"/>
        </div>
      </Subsections>

      <no-ssr>
        <AppModalFastOrder
          :visible="fastOrderModalShow"
          :order="fastOrder"
          :user="auth"
          v-scroll-lock="fastOrderModalShow"
          @before-close="hideFastOrderModal"/>
      </no-ssr>
    </template>

    <AppWarning
      v-else
      slot="content">
      <template #warning>
        <p class="paragraph">Проверьте номер: все ли цифры на месте, может быть, нужны еще буквы.</p>
        <p class="paragraph">
          Если вы точно знаете, что эта деталь существует, отправьте продавцам
          <flink
            class="link"
            href="/request-to-spare">
            Запрос на запчасть
          </flink>
        </p>
      </template>
    </AppWarning>
  </AppAbstractPage>
</template>

<script>
import {
  has,
  get,
  map,
  mapValues,
  omitBy,
  pickBy,
  transform,
} from 'lodash-es';
import { createNamespacedHelpers, mapMutations, mapState } from 'vuex';
import {
  HIDE_FAST_ORDER_MODAL,
  SHOW_FAST_ORDER_MODAL,
} from '~/assets/js/store/actionManager/mutation-types';
import { SET_FAST_ORDER } from '~/assets/js/store/root/mutation-types';

import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import AppTable from '~/components/redesign/app-table/app-table';
import AppSearch from '~/components/redesign/app-search/app-search';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputRadio from '~/components/redesign/app-input/app-input-radio';
import AppWarning from '~/components/redesign/app-warning';
import PpnFilters from '~/components/redesign/filter-groups/ppn-filters';
import AppModalFastOrder from '~/components/redesign/app-modals/app-modal-fast-order';
import PartApplicability from '~/components/redesign/part-applicability';
import AppEntitiesInMap from '~/components/redesign/app-map/app-entities-in-map';
import SelectSorting from '~/components/redesign/app-select/select-sorting';
import Subsections from '~/components/redesign/subsections';
import GridHeader from '~/components/redesign/grid/grid-header';
import GridOffers from '~/components/redesign/search-by-number/grid-offers';
import PpnWarning from '~/components/redesign/search-by-number/warning';
import GridCounterparts from '~/components/redesign/search-by-number/grid-counterparts';
import GoodsInfo from '~/components/redesign/search-by-number/goods-info';

import queryApplicabilityValidator from '~/assets/js/helpers/query-applicability-validator';
import mapFilters from '~/assets/js/helpers/map-filters';

// Mixin
import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/poisk-po-nomeru/part';
import isMobileMixin from '~/assets/js/mixins/is-mobile';

// Enums
import SubsectionsEnum from '~/assets/js/enums/product/subsections';
import OrderDirections from '~/assets/js/enums/order-directions';
import PartTypes from '~/assets/js/enums/part-types';
import GridTypes from '~/assets/js/enums/ppn-grid-types';
import DisplayStates from '~/assets/js/enums/ppn-display-states';
import { GeoLevel } from '~/backend/api-bundle/graphql/types';

import { currentOffer } from '~/assets/js/mocks/table/headings';
import SubsectionsStructures from '~/assets/js/structures/product/subsections';
import ApplicabilityRegularStructure from '~/assets/js/structures/applicability-regular';

const STORE_USER = createNamespacedHelpers('user');
const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');

const GRID = {
  offset: 0,
  limit: 10,
  data: [],
  order: {
    field: null,
    direction: null,
  },
};

const initFiltersModel = {
  filterLocation: null,
  filterIsWholesale: null,
  filterMinPrice: null,
  filterMaxPrice: null,
  filterManufacturer: null,
  filterShop: null,
  filterDelivery: null,
  filterRating: null,
  filterMetro: null,
  filterOpenedNow: null,
};

export default {
  name: 'SearchByNumberPart',
  components: {
    PartApplicability,
    SelectSorting,
    PpnFilters,
    AppAbstractPage,
    AppButton,
    AppInputRadio,
    AppTable,
    AppModalFastOrder,
    AppWarning,
    AppSearch,
    AppEntitiesInMap,
    Subsections,
    GridHeader,
    GridOffers,
    PpnWarning,
    GridCounterparts,
    GoodsInfo,
  },
  mixins: [SeoMixin, SeoPageMixin, isMobileMixin],
  middleware: ['new-parts'],
  async asyncData({
    app,
    error,
    store,
    route,
  }) {
    const count = 0;
    const defaultGrid = Object.assign({}, GRID, {
      count,
      limit: store.state.isBot ? 50 : 10,
    });
    const grids = {
      [GridTypes.INTERNAL_ORIGINAL]: { ...defaultGrid },
      [GridTypes.INTERNAL_COUNTERPART]: { ...defaultGrid },
      [GridTypes.FOREIGN_ORIGINAL]: { ...defaultGrid },
      [GridTypes.FOREIGN_COUNTERPART]: { ...defaultGrid },
    };

    // предустановленная локация может быть из query, либо из store
    let resolvedFilterLocation = null;
    if (has(route.query, 'location')) {
      if (route.query.location) {
        try {
          const { data: locationValues } = await app.$axios.$get('/_main/geo/get', {
            params: { ids: [route.query.location] },
          });
          resolvedFilterLocation = locationValues.find(region => Number(region.id) === Number(route.query.location));
        } catch (e) {
          console.error(e);
        }
      }
    } else if (store.state.location.id) {
      resolvedFilterLocation = { ...store.state.location };
    }

    const filtersModel = Object.assign({}, initFiltersModel, {
      filterLocation: resolvedFilterLocation
        ? { id: resolvedFilterLocation.id, name: resolvedFilterLocation.name }
        : null,
    });

    const apiRequestParamsInfo = {
      criteria: {
        partManufacturer: route.params.manufacturer,
        partVendorCode: route.params.vendorCode,
        geoId: store.state.location.id,
      },
    };
    const apiRequestParamsHash = {
      manufacturer: route.params.manufacturer,
      vendorCode: route.params.vendorCode,
      criteria: {
        filterLocation: resolvedFilterLocation && resolvedFilterLocation.id,
      },
    };
    const [
      partInfoRaw,
      gridInfo,
    ] = await Promise.all([
      app.$axios.$get('/_main/partInfo/get', { params: apiRequestParamsInfo }).catch((e) => {
        console.error(e);
        if (get(e, 'response.data.error.errorCode', null) === 404) {
          error({ statusCode: 404 });
        } else {
          error({ statusCode: 500 });
        }
      }),
      app.$axios.$get('/_main/part/filter', { params: apiRequestParamsHash }).catch((e) => { console.error(e); }),
    ]);

    const partInfo = (partInfoRaw && partInfoRaw.data) || {};
    const hash = (gridInfo && gridInfo.data.hash) || '';
    const filtersValues = (gridInfo && gridInfo.data.filters) || {};

    // partInfo.partImages = [
    //   'https://gisauto.ru/bundles/gisautoweb/images/catalog/parts/000/001/187/661/1.jpg', // luk 602000800
    //   'https://gisauto.ru/bundles/gisautoweb/images/catalog/parts/000/001/269/458/1.jpg', // ngk 6240
    // ];
    const result = {
      hash,
      count,
      grids,
      filtersValues,
      filtersModel,
      resolvedFilterLocation,
      partInfo: {
        type: partInfo.partType,
        valid: partInfo.partType === PartTypes.VALID,
        partName: partInfo.partName,
        partManufacturer: partInfo.partManufacturer,
        partVendorCode: partInfo.partVendorCode,
        partCarModels: partInfo.partCarModels || '',
        images: partInfo.partImages && partInfo.partImages.length
          ? partInfo.partImages.map((src, index) => ({
            src,
            alt: [
              partInfo.partName,
              `(${partInfo.partManufacturer}, ${partInfo.partVendorCode})`,
              partInfo.partImages.length > 1 ? `- фото ${index + 1}` : '',
            ].filter(Boolean).join(' '),
          }))
          : [],
        aliases: partInfo.partNameAliases ? partInfo.partNameAliases.join(', ') : '',
        description: partInfo.description || '',
        characteristics: get(partInfo, 'tecdoc.characteristics', []),
        counterparts: partInfo.counterparts || [],
        additionalVendorCodes: partInfo.additionalVendorCode && partInfo.additionalVendorCode.length
          ? `[${partInfo.additionalVendorCode.join(', ')}]`
          : '',
        applicability: partInfo.carTypes || [],
        minPrice: partInfo.minPrice,
        maxPrice: partInfo.maxPrice,
      },
    };

    // не инвалидная запчасть, но почему-то не сформировался хэш - 500
    if (result.partInfo.valid && !hash) {
      error({ statusCode: 500 });
      return result;
    }

    // инвалидная запчасть - нет смысла делать запросы на гриды
    if (!result.partInfo.valid) {
      return result;
    }

    try {
      const gridResults = await Promise.all([
        app.$axios.$get('/_main/part/list', {
          params: {
            criteria: { hash, availability: GridTypes.INTERNAL_ORIGINAL },
            limit: defaultGrid.limit,
            filterLocation: resolvedFilterLocation && resolvedFilterLocation.id,
          },
        }),
        app.$axios.$get('/_main/part/list', {
          params: {
            criteria: { hash, availability: GridTypes.INTERNAL_COUNTERPART },
            limit: defaultGrid.limit,
            filterLocation: resolvedFilterLocation && resolvedFilterLocation.id,
          },
        }),
        app.$axios.$get('/_main/part/list', {
          params: {
            criteria: { hash, availability: GridTypes.FOREIGN_ORIGINAL },
            limit: defaultGrid.limit,
            filterLocation: resolvedFilterLocation && resolvedFilterLocation.id,
          },
        }),
        app.$axios.$get('/_main/part/list', {
          params: {
            criteria: { hash, availability: GridTypes.FOREIGN_COUNTERPART },
            limit: defaultGrid.limit,
            filterLocation: resolvedFilterLocation && resolvedFilterLocation.id,
          },
        }),
      ]);

      gridResults.forEach(({ data }) => {
        const gridType = data.type || null;
        const gridData = data.data || [];
        const gridCount = data.count || 0;

        if (gridType !== null) {
          result.grids[gridType].data = gridData;
          result.grids[gridType].count = gridCount;
        }
      });
    } catch (e) {
      console.error(e);
    }

    // TODO убрать это на бэк
    if (filtersValues && filtersValues.filterRating && filtersValues.filterRating.length) {
      result.filtersValues.filterRating.sort((a, b) => {
        if (Number(a.id) > Number(b.id)) {
          return -1;
        }
        if (Number(a.id) < Number(b.id)) {
          return 1;
        }

        return 0;
      });
    }

    return result;
  },
  data() {
    return {
      loading: false,
      apiCriteria: {},
      listParams: {
        filterIsWholesale: 'isWholesale',
        filterMinPrice: 'minPrice',
        filterMaxPrice: 'maxPrice',
        filterOpenedNow: 'openedNow',
      },
      scalarFilters: ['filterMinPrice', 'filterMaxPrice', 'filterOpenedNow', 'filterIsWholesale'],
      ref: {
        PartTypes,
      },
      expandedRows: [],
      showTooltip: null,
      hasModalApplicability: false,
      currentImages: [],
      isLightBox: false,
      activeTypes: null,
      noneRegularGrids: {
        // AVAILABILITY_RESULT_ORIGINAL, AVAILABILITY_RESULT_COUNTERPART - keys
        [GridTypes.INTERNAL_ORIGINAL]: Object.assign({}, GRID, { limit: 0 }),
        [GridTypes.INTERNAL_COUNTERPART]: Object.assign({}, GRID, { limit: 0 }),
      },
      withoutCityGrids: {
        [GridTypes.INTERNAL_ORIGINAL]: Object.assign({}, GRID, { limit: 0 }),
        [GridTypes.INTERNAL_COUNTERPART]: Object.assign({}, GRID, { limit: 0 }),
      },
      isShowMap: false,
      display: DisplayStates.LIST,
      filtersMobileScrollable: false,
      selectedSorting: null,
    };
  },
  computed: {
    ...mapState(['location', 'sessionId', 'fastOrder', 'currentCartItem']),
    ...STORE_USER.mapState(['auth']),
    ...STORE_ACTION_MANAGER.mapState(['fastOrderModalShow']),
    currentGrids() {
      return this.isShowMap ? this.noneRegularGrids : this.grids;
    },
    mapGrid() {
      return this.getMapGrid(this.noneRegularGrids);
    },
    name() {
      const isQueryApplicabilityValid = queryApplicabilityValidator(
        this.$route.query.brand,
        this.$route.query.model,
        this.partInfo && this.partInfo.carTypes ? this.partInfo.carTypes : [],
      );
      const result = [this.partInfo.partName];
      if (this.partInfo.partCarModels) {
        result.push(this.partInfo.partCarModels);
      } else if (isQueryApplicabilityValid) {
        result.push(`${this.$route.query.brand} ${this.$route.query.model}`);
      }
      return result.join(' ');
    },
    titleH1() {
      if (!this.partInfo.valid) {
        return `К сожалению, мы не нашли запчасти по вашему запросу ${this.partInfo.partVendorCode}`;
      }
      return [
        `${this.partInfo.partManufacturer}${this.partInfo.partManufacturer === 'MOBIS' ? ' [Hyundai/KIA]' : ''},`,
        this.partInfo.partVendorCode,
        this.partInfo.additionalVendorCodes,
        `- ${this.name}`,
      ].join(' ');
    },
    offerTitle() {
      let metroSuffix = '';
      if (this.filtersModel.filterMetro && this.filtersModel.filterMetro.name) {
        metroSuffix = ` (метро ${this.filtersModel.filterMetro.name})`;
      }
      const locationSuffix = this.resolvedFilterLocation
        ? `в ${this.resolvedFilterLocation.prepositionalName}${metroSuffix}`
        : 'во всех странах';

      return [
        'Найдено',
        this.grids[GridTypes.INTERNAL_ORIGINAL].count,
        this.transChoose(
          this.grids[GridTypes.INTERNAL_ORIGINAL].count,
          ['предложение', 'предложения', 'предложений']
        ),
        'запрошенной детали',
        locationSuffix,
      ].join(' ');
    },
    gridsInfo() {
      return mapValues(
        this.grids,
        (grid, type) => {
          let name = '';

          if (this.filtersModel.filterLocation) {
            switch (type) {
              case GridTypes.INTERNAL_ORIGINAL:
                name = `${this.getOfferTitleByGridType(grid.count)}`;
                break;
              case GridTypes.INTERNAL_COUNTERPART:
                name = `Аналоги и заменители для ${this.getOfferTitleByGridType(grid.count)}`;
                break;
              case GridTypes.FOREIGN_ORIGINAL:
                name = `${this.getOfferTitleByGridType(grid.count)} в других городах`;
                break;
              case GridTypes.FOREIGN_COUNTERPART:
                name = `Аналоги и заменители для ${this.getOfferTitleByGridType(grid.count)} в других городах`;
                break;
              default:
            }
          } else {
            switch (type) {
              case GridTypes.INTERNAL_ORIGINAL:
              case GridTypes.FOREIGN_ORIGINAL:
                name = `${this.getOfferTitleByGridType(grid.count)}`;
                break;
              case GridTypes.INTERNAL_COUNTERPART:
              case GridTypes.FOREIGN_COUNTERPART:
                name = `Аналоги и заменители для ${this.getOfferTitleByGridType(grid.count)}`;
                break;
              default:
            }
          }
          return {
            name,
            countShown: this.lazyLoadEnabled(type) ? grid.limit + grid.offset : grid.count,
            ...grid,
          };
        },
      );
    },
    gridTypesByCity() {
      return Object.values(this.$options.gridTypes)
        .filter(gridType => gridType === GridTypes.INTERNAL_ORIGINAL || gridType === GridTypes.INTERNAL_COUNTERPART);
    },
    gridTypesWithoutCity() {
      return Object.values(this.$options.gridTypes)
        .filter(gridType => gridType === GridTypes.FOREIGN_ORIGINAL || gridType === GridTypes.FOREIGN_COUNTERPART);
    },
    gridsByTypes() {
      const grids = this.countOffersRegularGrids ? this.gridTypesByCity : this.gridTypesWithoutCity;
      return grids.filter(type => this.gridsInfo[type].count);
    },
    countOffersMapGrids() {
      return this.mapGrid[GridTypes.INTERNAL_ORIGINAL].count + this.mapGrid[GridTypes.INTERNAL_COUNTERPART].count;
    },
    countOffersRegularGrids() {
      return this.grids[GridTypes.INTERNAL_ORIGINAL].count + this.grids[GridTypes.INTERNAL_COUNTERPART].count;
    },
    countPartsWithoutCity() {
      return this.grids[GridTypes.FOREIGN_ORIGINAL].count + this.grids[GridTypes.FOREIGN_COUNTERPART].count;
    },
    countOriginal() {
      return this.grids[GridTypes.INTERNAL_ORIGINAL].count + this.grids[GridTypes.FOREIGN_ORIGINAL].count;
    },
    countCounterpart() {
      return this.grids[GridTypes.INTERNAL_COUNTERPART].count + this.grids[GridTypes.FOREIGN_COUNTERPART].count;
    },
    countFiltersSelected() {
      return Object.keys(this.apiCriteria).length;
    },
    apiRequestHashParams() {
      return {
        manufacturer: this.$route.params.manufacturer,
        vendorCode: this.$route.params.vendorCode,
        criteria: this.apiCriteria,
      };
    },
    unboundFiltersModel() {
      return Object.assign({}, this.filtersModel);
    },
    breadcrumbs() {
      const breadcrumbsFull = [
        {
          url: '/poisk-po-nomeru',
          name: 'Поиск по номеру',
        },
        {
          url: '',
          name: `${this.partInfo.partManufacturer ? this.partInfo.partManufacturer : ''}`,
        },
        {
          url: '',
          name: `${this.partInfo.partVendorCode ? this.partInfo.partVendorCode : ''}`,
        },
      ];

      const breadcrumbs = [
        {
          url: '/poisk-po-nomeru',
          name: 'Поиск по номеру',
        },
      ];

      return this.partInfo.valid ? breadcrumbsFull : breadcrumbs;
    },
    hasMap() {
      return (this.resolvedFilterLocation && (this.resolvedFilterLocation.level === GeoLevel.City)
              && Boolean(this.filtersModel.filterLocation && this.filtersModel.filterLocation.id)
              && !this.loading);
    },
    mapButtonDisabled() {
      return (!this.hasMap && !this.countOffersRegularGrids)
        || !this.countOffersRegularGrids;
    },
    mapTooltipButton() {
      if (this.hasMap && !this.countOffersRegularGrids) {
        return {
          ...this.$options.tooltipMapButton,
          // eslint-disable-next-line
          content: 'В выбранном городе нет предложений.<br/>Выберите другой город, чтобы посмотреть <br>предложения на карте',
        };
      }

      if (this.hasMap) {
        return '';
      }

      return this.$options.tooltipMapButton;
    },
    sorting() {
      return this.$options.headingsCurrentOffer
        .filter(entry => entry.sorting.has)
        .reduce((acc, entry) => acc.concat(
          {
            id: `${OrderDirections.ASC}${entry.sorting.criteria}`,
            criteria: entry.sorting.criteria,
            titleMobile: entry.titleMobile,
            direction: OrderDirections.ASC,
          },
          {
            id: `${OrderDirections.DESC}${entry.sorting.criteria}`,
            criteria: entry.sorting.criteria,
            titleMobile: entry.titleMobile,
            direction: OrderDirections.DESC,
          }
        ), []);
    },
    gridOriginal() {
      return this.grids[GridTypes.INTERNAL_ORIGINAL];
    },
    gridCounterparts() {
      const counterparts = (this.partInfo.counterparts || [])
        .filter(entry => entry.all_offers_count);
      return {
        data: counterparts,
        count: counterparts.length,
      };
    },
    gridCounterpartsTotalAmount() {
      return this.gridCounterparts.data.reduce((acc, currentEntry) => acc + currentEntry.all_offers_count, 0);
    },
    subsections() {
      return SubsectionsStructures.reduce((acc, subsection) => acc.concat({
        ...subsection,
        ...(({ name }) => {
          switch (name) {
            case SubsectionsEnum.CHARACTERISTICS:
              return {
                count: 0,
                has: Boolean(this.partInfo.characteristics.length),
              };
            case SubsectionsEnum.APPLICABILITY:
              return {
                count: 0,
                has: Boolean(this.partInfo.applicability.length),
              };
            case SubsectionsEnum.ORIGIN:
              return {
                count: this.gridOriginal.count,
                has: true,
              };
            case SubsectionsEnum.ANALOG:
              return {
                count: this.gridCounterparts.count,
                has: Boolean(this.gridCounterparts.count),
              };
            default:
              return null;
          }
        })(subsection),
      }), []);
    },
    activeSubsection() {
      switch (this.$route.query.tab) {
        case SubsectionsEnum.CHARACTERISTICS: return SubsectionsEnum.CHARACTERISTICS;
        case SubsectionsEnum.APPLICABILITY: return SubsectionsEnum.APPLICABILITY;
        case SubsectionsEnum.ORIGIN: return SubsectionsEnum.ORIGIN;
        case SubsectionsEnum.ANALOG: return SubsectionsEnum.ANALOG;
        default: return SubsectionsEnum.ORIGIN;
      }
    },
  },
  watch: {
    unboundFiltersModel: {
      async handler(newValue, oldValue) {
        const changedFilters = omitBy(newValue, (v, k) => oldValue[k] === v);

        if (!changedFilters || !Object.keys(changedFilters).length) {
          return false;
        }

        const changedFilterName = Object.keys(changedFilters)[0];
        const isChangedFilterScalar = this.scalarFilters.includes(changedFilterName);
        const changedFilterSavedValues = this.filtersValues[changedFilterName];

        const rehash = !has(this.listParams, changedFilterName);

        this.apiCriteria = mapValues(
          pickBy(this.filtersModel, item => Boolean(item)),
          (item, key) => (this.scalarFilters.includes(key) ? item : item.id),
        );

        if (changedFilterName === 'filterLocation') {
          if (this.filtersModel.filterLocation) {
            try {
              const { data: locationValues } = await this.$axios.$get('/_main/geo/get', {
                params: { ids: [this.filtersModel.filterLocation.id] },
              });
              this.resolvedFilterLocation = locationValues[0];
            } catch (e) {
              console.error(e);
              this.$error({ statusCode: 500 });
            }
          } else {
            this.resolvedFilterLocation = null;
          }
        }

        if (rehash) {
          await this.rehash();
        }

        await this.loadNewData();

        if (
          Object.keys(changedFilters).length === 1
          && !isChangedFilterScalar
          && changedFilterSavedValues.length > 1
        ) {
          this.filtersValues[changedFilterName] = changedFilterSavedValues;
        }

        return true;
      },
      deep: true,
    },
    async isShowMap() {
      if (!this.hasMap && !this.isShowMap) {
        return false;
      }
      return false;
    },
    'location.id'() {
      // this.filtersModel.filterLocation = {
      //   id: this.location.id,
      //   name: this.location.name,
      // };
      // Обговоренно с Зиной
      this.isShowMap = false;
      this.resetFilters();
    },
  },
  created() {
    this.$options.gridTypes = GridTypes;
    this.$options.displayStates = DisplayStates;
    this.$options.applicabilityStructure = ApplicabilityRegularStructure;
    this.$options.headingsCurrentOffer = currentOffer;
    this.$options.tooltipPartDiscountPrice = {
      content: 'Скажите, что вы с ГисАвто и получите скидку',
      placement: 'left-start',
      html: true,
      trigger: 'hover',
      offset: 4,
      classes: 'tooltipDark tooltipDiscount',
      delay: 0,
    };
    this.$options.tooltipMapButton = {
      content: 'Выберите город, чтобы посмотреть <br>предложения на карте',
      placement: 'bottom-start',
      html: true,
      trigger: 'click',
      offset: 16,
      classes: 'tooltip tooltipDark tooltipMapButton',
      delay: 0,
    };
  },
  mounted() {
    this.$ym('ppn_stat_searched_part', {
      session_id: this.sessionId,
      part_art: this.partInfo.partVendorCode,
      part_name: this.partInfo.partName,
      found: Boolean(this.grids[GridTypes.INTERNAL_ORIGINAL].count),
    });

    this.selectedSorting = this.sorting[1];
  },
  methods: {
    ...mapMutations({
      setFastOrder: SET_FAST_ORDER,
    }),
    ...mapFilters(['vendorCodeSlug', 'brandSlug', 'transChoose']),
    ...STORE_ACTION_MANAGER.mapMutations({
      showFastOrderModal: SHOW_FAST_ORDER_MODAL,
      hideFastOrderModal: HIDE_FAST_ORDER_MODAL,
    }),
    getMapGrid(grids) {
      // TODO: Обсудить с Андреем
      const result = Object.keys(grids).reduce((acc, value) => {
        const data = grids[value].data.filter(entry => entry.coord_lat && entry.coord_lng);
        const title = `${this.getTitleGrid(value, data.length)}`;

        // return {
        // AVAILABILITY_RESULT_ORIGINAL: ...
        // AVAILABILITY_RESULT_COUNTERPART: ...
        // }
        return {
          ...acc,
          [value]: {
            ...grids[value],
            data,
            count: data.length,
            title,
          },
        };
      }, {});

      return result;
    },
    async loadNewData(fetchingType = null) {
      this.loading = true;

      if (this.isShowMap) {
        map(this.grids, (grid) => {
          grid.offset = 0;
          return grid;
        });

        try {
          const temporaryGrid = await Promise.all(
            Object
              .keys(this.grids)
              .filter(gridType => !fetchingType || fetchingType === gridType)
              .map(gridType => this.fetchNewData(this.grids, gridType))
          );

          temporaryGrid.forEach(({ data, type, count }) => {
            this.grids[type] = {
              ...this.grids[type],
              data,
              count,
            };
          });
        } catch (e) {
          console.error(e);
          return false;
        }
      }

      map(this.currentGrids, (grid) => {
        grid.offset = 0;
        return grid;
      });

      try {
        const temporaryGrid = await Promise.all(
          Object
            .keys(this.currentGrids)
            .filter(gridType => !fetchingType || fetchingType === gridType)
            .map(gridType => this.fetchNewData(this.currentGrids, gridType))
        );

        temporaryGrid.forEach(({ data, type, count }) => {
          this.currentGrids[type] = {
            ...this.currentGrids[type],
            data,
            count,
          };
        });
      } catch (e) {
        console.error(e);
        return false;
      } finally {
        this.loading = false;
      }

      return true;
    },
    async rehash() {
      const gridInfo = await this.$axios.$get('/_main/part/filter', {
        params: this.apiRequestHashParams,
      }).catch((e) => {
        console.error(e);
        this.loading = false;
      });
      this.hash = (gridInfo && gridInfo.data.hash) || '';
      this.filtersValues = (gridInfo && gridInfo.data.filters) || {};
    },
    async fetchNewData(grid, fetchingType) {
      try {
        const {
          data: {
            data,
            type,
            count,
          },
        } = await this.$axios.$get('/_main/part/list', {
          params: this.apiRequestListParams(grid, fetchingType),
        });
        return { data, type, count };
      } catch (e) {
        console.error(e);
        return {};
      }
    },
    async showMore(type) {
      if (!this.lazyLoadEnabled(type)) {
        return false;
      }

      this.grids[type].offset += this.grids[type].limit;
      this.loading = true;

      const { data } = await this.fetchNewData(this.currentGrids, type, this.grids[type]);

      this.loading = false;
      this.grids[type].data = this.grids[type].data.concat(data);

      return true;
    },
    async onShowGrids() {
      this.isShowMap = false;
    },
    fetchByOrder(type, order) {
      if (type === GridTypes.INTERNAL_ORIGINAL || type === GridTypes.INTERNAL_COUNTERPART) {
        this.currentGrids[GridTypes.INTERNAL_ORIGINAL].order = order;
        this.currentGrids[GridTypes.INTERNAL_COUNTERPART].order = order;
        this.loadNewData(GridTypes.INTERNAL_ORIGINAL);
        this.loadNewData(GridTypes.INTERNAL_COUNTERPART);
      } else {
        this.currentGrids[GridTypes.FOREIGN_ORIGINAL].order = order;
        this.currentGrids[GridTypes.FOREIGN_COUNTERPART].order = order;
        this.loadNewData(GridTypes.FOREIGN_ORIGINAL);
        this.loadNewData(GridTypes.FOREIGN_COUNTERPART);
      }
    },
    onOrderChange(entry) {
      this.selectedSorting = entry;

      this.fetchByOrder(this.gridType, {
        field: entry.criteria,
        direction: entry.direction,
      });
    },
    mapHeading(types, count) {
      if (!this.partInfo.valid) {
        return `К сожалению, мы не нашли запчасти по вашему запросу ${this.partInfo.partVendorCode}`;
      }

      if (types.length === 2) {
        return `${count} предложений запрошенной детали`;
      }

      if (types[0] === 'originals') {
        return `Оригинал ${this.getOfferTitleByGridType(count)}`;
      }

      return `Аналоги и заменители для ${this.getOfferTitleByGridType(count)}`;
    },
    getTitleGrid(gridType, count) {
      const offerTitle = gridType === GridTypes.INTERNAL_ORIGINAL ? 'Оригинал' : 'Аналоги и заменители для';
      return `${offerTitle} ${this.getOfferTitleByGridType(count)}`;
    },
    getApiRequestCriteria(type) {
      return {
        criteria: {
          hash: this.hash,
          availability: type,
          ...transform(
            pickBy(this.apiCriteria, (item, key) => has(this.listParams, key)),
            (result, item, key) => {
              result[this.listParams[key]] = item;
            },
          ),
        },
        filterLocation: this.filtersModel.filterLocation ? this.filtersModel.filterLocation.id : null,
      };
    },
    apiRequestListParams(grid, type) {
      return {
        ...this.getApiRequestCriteria(type),
        limit: grid[type].limit,
        offset: grid[type].offset,
        orderField: grid[type].order.field,
        orderDirection: grid[type].order.direction,
      };
    },
    changeDisplay(target) {
      if (!Object.values(DisplayStates).includes(target)) {
        return false;
      }
      this.display = target;
      this.filtersMobileScrollable = target === DisplayStates.FILTERS;

      return true;
    },
    typeChange(type) {
      // TODO: За чем это?
      type = type.toLowerCase();
      const element = document.getElementById(`type__${type}`);
      if (element) {
        if (window.innerWidth <= 1024) {
          Object.keys(this.grids).forEach(gridType => this.$refs[`grid__${gridType.toLowerCase()}`].hide());
          this.$refs[`grid__${type}`].show();
        } else {
          const elementRect = element.getBoundingClientRect();
          const absoluteElementTop = elementRect.top + window.pageYOffset;
          window.scrollTo(0, absoluteElementTop - 70);
        }
      }
    },
    lazyLoadEnabled(type) {
      return this.grids[type].count > this.grids[type].limit
              && (this.grids[type].limit + this.grids[type].offset) < this.grids[type].count;
    },
    fastOrderShow(part) {
      this.setFastOrder(part);
      this.showFastOrderModal();
    },
    getOfferTitleByGridType(offer) {
      const partInfo = `${this.partInfo.partManufacturer}, ${this.partInfo.partVendorCode}: `;
      const counter = count => `${count} ${this.transChoose(count, ['предложение', 'предложения', 'предложений'])}`;

      return `${partInfo}${counter(offer)}`;
    },
    resetFilters() {
      if (this.loading) {
        return false;
      }

      this.filtersModel = {
        ...initFiltersModel,
        filterLocation: {
          id: this.location.id,
          name: this.location.name,
        },
      };
      return true;
    },
    onClearFilterLocation() {
      // this.isShowMap = false;
    },
    async fetchMapGridResults() {
      if (!this.hasMap && !this.isShowMap) {
        return false;
      }

      this.loading = true;

      const filterLocation = this.filtersModel.filterLocation ? this.filtersModel.filterLocation.id : null;
      try {
        const gridResultsMap = await Promise.all([
          this.$axios.$get('/_main/part/list', {
            params: {
              criteria: { hash: this.hash, availability: GridTypes.INTERNAL_ORIGINAL },
              filterLocation,
            },
          }),
          this.$axios.$get('/_main/part/list', {
            params: {
              criteria: { hash: this.hash, availability: GridTypes.INTERNAL_COUNTERPART },
              filterLocation,
            },
          }),
        ]);

        gridResultsMap.forEach(({ data }) => {
          const gridType = data.type || null;
          const gridData = data.data || [];
          const gridCount = data.count || 0;

          if (gridType !== null) {
            this.noneRegularGrids[gridType] = {
              ...this.noneRegularGrids[gridType],
              data: gridData,
              count: gridCount,
              title: `${this.getTitleGrid(gridType, gridCount)}`,
            };
          }
        });
      } catch (err) {
        console.log(err);
      }

      this.loading = false;
      return true;
    },
    onSwitchMap(isShowMapValue) {
      this.isShowMap = isShowMapValue;

      if (isShowMapValue) {
        this.fetchMapGridResults();
      }
    },
  },
};
</script>

<style lang="postcss">
.tooltipDiscount {
  max-width: 10rem;
}

.tooltipLinkSeller {
  margin-top: -0.25rem;
}

.tooltipMapButton {
  position: fixed!important;
  width: 100%;
  max-height: 120px;
  height: auto;
  transform: none!important;
  top: auto!important;
  bottom: 10px;
  padding: 12px;

  .tooltip-arrow {
    display: none;
  }
}

.goodsInfoPage {
  padding-bottom: 4rem;

  .boxList {
    display: block;
    padding-top: 0.5rem;
    font-size: 0.875rem;

    &-item {
      display: flex;
      align-items: flex-end;
      margin-bottom: 0.5rem;
      border-bottom: 1px dashed var(--border-color-light);
    }

    &-name {
      width: 60%;
      font-weight: var(--font-weight-medium);
    }

    &-value {
      width: 40%;
      text-align: right;
    }

    &-name, &-value {
      margin-bottom: -2px;

      > span {
        display: inline-block;
        background-color: var(--bg-main);
      }
    }
  }

  @media screen and (min-width: 981px) {
    .offers {
      &-controlDisplay {
        display: flex;
        justify-content: flex-end;
        padding: 1rem 0 0.5rem;
        margin-bottom: -3.375rem;

        &.-is-mobile {
          display: none;
        }

      }

      .gridOriginal {
        padding-top: 1.5rem;
      }
    }

    .map-header {
      padding-top: 1.5rem;
      padding-bottom: .5rem;
    }
  }

  @media screen and (max-width: 980px) {
    .boxList {
      &-item {
        align-items: flex-start;
        margin-bottom: 0.5rem;
        border: none;
      }
      &-name {
        margin: 0;
        padding-right: 0.5rem;
        color: var(--color-main-lightest);
        font-weight: var(--font-weight-regular);
      }
      &-value {
        margin: 0;
        width: 50%;
        text-align: left;
      }

    }

    .offers {
      &-filters {
        display: none;

        &.-open-in-mobile {
          display: block;
        }
      }

      &-controlDisplay {
        position: relative;
        z-index: 10;
        display: flex;
        flex-wrap: wrap;
        padding: 1rem 1.25rem;
        width: 100%;
        box-shadow: 0 1px 2px rgba(0, 0, 0, .2);

        .button {
          flex-grow: 1;
          width: calc(50% - 1rem);
          font-size: 1rem;

          + .button {
            margin-left: 1rem;
          }
        }

        &.-is-desktop {
          display: none;
        }
      }

      .gridOriginal {
        border-top: 0.625rem solid var(--bg-dark);
      }
    }
  }
}
</style>
